; =================================================================================================
; Title:   Demo01A.asm
; Author:  G. Friedrich, June 2003
; Version: 1.0.0
; Purpose: Demonstration Application 01A of ObjAsm32.
; =================================================================================================


%include @Environ(OA32_PATH)\\Code\\Macros\\Model.inc  ;Include & initialize standard modules
SysSetup OOP_NONE, DEBUG(WND)                     ;Loads OOP files and OS related objects

include \masm32\include\urlmon.inc
includelib \masm32\lib\urlmon.lib


;BEGIN_INTERFACE IBindStatusCallback, IUnknown, <79EAC9C1-BAF9-11CE-8C82-00AA004BA90B>
;  STDMETHOD   OnStartBinding,               dword, Pointer
;  STDMETHOD   GetPriority,                  Pointer
;  STDMETHOD   OnLowResource,                dword
;  STDMETHOD   OnProgress,                   dword, dword, dword, Pointer
;  STDMETHOD   OnStopBinding,                HRESULT, Pointer
;  STDMETHOD   GetBindInfo,                  Pointer, Pointer
;  STDMETHOD   OnDataAvailable,              dword, dword, Pointer, Pointer
;  STDMETHOD   OnObjectAvailable,            Pointer, Pointer
;END_INTERFACE

IBINDSTATUSCALLBACK STRUCT
  QueryInterface      DWORD offset QueryInterfaceProc
  AddRef              DWORD offset AddRefProc
  Release             DWORD offset ReleaseProc
  OnStartBinding      DWORD offset OnStartBindingProc
  GetPriority         DWORD offset GetPriorityProc
  OnLowResource       DWORD offset OnLowResourceProc
  OnProgress          DWORD offset OnProgressProc
  OnStopBinding       DWORD offset OnStopBindingProc
  GetBindInfo         DWORD offset GetBindInfoProc
  OnDataAvailable     DWORD offset OnDataAvailableProc
  OnObjectAvailable   DWORD offset OnObjectAvailableProc
IBINDSTATUSCALLBACK ENDS

.data                                               ;Define global variables in the Data segment
sIBindStatusCallback  IBINDSTATUSCALLBACK <>

pIBindStatusCallback  DWORD offset sIBindStatusCallback

.code                                               ;Begin Code segment

QueryInterfaceProc PROC Self:dword, riid:DWORD, ppv:DWORD
  DbgText "QueryInterfaceProc"
  mov eax, E_NOTIMPL
  ret
QueryInterfaceProc ENDP

AddRefProc PROC Self:dword
  DbgText "AddRefProc"
  mov eax, S_OK
  ret
AddRefProc ENDP

ReleaseProc PROC Self:dword 
  DbgText "ReleaseProc"
  mov eax, S_OK
  ret
ReleaseProc ENDP

OnObjectAvailableProc PROC Self:dword, riid:DWORD, punk:DWORD
  DbgText "OnObjectAvailableProc"
  mov eax, S_OK
  ret
OnObjectAvailableProc ENDP

OnDataAvailableProc PROC Self:dword, grfBSCF:DWORD, dwSize:DWORD,pfmtetc:DWORD,pstgmed:DWORD
  DbgText "OnDataAvailableProc"
  mov eax, S_OK
  ret
OnDataAvailableProc ENDP

OnStopBindingProc PROC Self:dword, hrResult:DWORD, szError:DWORD
  DbgText "OnStopBindingProc"
  mov eax, S_OK
  ret
OnStopBindingProc ENDP

GetBindInfoProc PROC Self:dword, pgrfBINDF:DWORD, pbindinfo:DWORD
  DbgText "GetBindInfoProc"
  mov eax, S_OK
  ret
GetBindInfoProc ENDP

OnLowResourceProc PROC Self:dword, dwReserved:DWORD
  DbgText "OnLowResourceProc"
  mov eax, S_OK
  ret
OnLowResourceProc ENDP

GetPriorityProc PROC Self:dword, pnPriority:DWORD
  DbgText "GetPriorityProc"
  mov eax, S_OK
  ret
GetPriorityProc ENDP

OnStartBindingProc PROC Self:dword, grfBSCOption:DWORD, pbinding:DWORD
  DbgText "OnStartBindingProc"
  mov eax, S_OK
  ret
OnStartBindingProc ENDP

OnProgressProc PROC Self:dword, ulProgress:DWORD,ulProgressMax:DWORD,ulStatusCode:DWORD,szStatusText:DWORD
  DbgText "OnProgressProc"
;  @invoke MessageBox, NULL, "yay", NULL, MB_OK
  mov eax, S_OK
  ret
OnProgressProc ENDP


start:                                              ;Program entry point
    SysInit                                         ;Runtime initialization of the OOP model
    
    @invoke URLDownloadToFile, NULL, "http://x86assembly.codegurus.org/GeneSys.zip", "GeneSys.zip", NULL, offset pIBindStatusCallback
    .if eax != S_OK
      @invoke MessageBox, NULL, "Download Failed.", NULL,  MB_OK
    .endif
    invoke ExitProcess, 0

    SysDone                                         ;Runtime finalization of the OOP model

    invoke ExitProcess, 0                           ;Exit program returning 0 to Windows OS
end start                                           ;End of code and define the program entry point